#include "core.h"
#include "fcie.h"
#define _USE_MATH_DEFINES
#include "math.h"

void core::newton(void (*pt2f)(matica &prud, matica& Ka, matica& pe, matica& res), matica& prud, matica& Ka, matica& pe, matica& ret)
{				// NUMERICKE RIESENIE POMOCOU NEWTONOVEJ METODY //
	matica res(prud.row,prud.col), res_1(prud.row,prud.col);
	matica jac(Ka.row,Ka.col);
	matica der(prud.row,prud.col), pom(prud.row,prud.col), pomh(prud.row,prud.col), num(prud.row, prud.col);
	I1.alloc(jac.row,num.col);
	int maxIter = 300, check = 0, q = 0;
	

	for(int i=0; i<prud.count; i++)
		res_1.mat[i] = prud.mat[i];

	while(check != 1 && maxIter > 0)
	{
		maxIter--;
		q = 0;

		pt2f(res_1,Ka,pe,num);
		for(int i=0; i<jac.col; i++)
		{
			for(int j=0; j<pom.count; j++)
			{
				pom.mat[j] = 1e-6;
				if(i == j)
					pomh.mat[j] = 1e-6;
				else
					pomh.mat[j] = 0.;
			}

			for(int j=0; j<pomh.count; j++)
				pomh.mat[j] = res_1.mat[j] + pomh.mat[j];
			pt2f(pomh,Ka,pe,der);
			for(int j=0; j<der.count; j++)
				der.mat[j] = (der.mat[j] - num.mat[j]) / pom.mat[j];
			for(int j=0; j<jac.row; j++)
				jac.mat[i*jac.col+j] = der.mat[j];
		}
		for(int i=0; i<jac.count; i++)
			Ij1.mat[i] = jac.mat[i];
		
		Ij2.eye();
		jac.inv(Ij1,Ij2);
		
		

		I1.nasob(jac,num);
		for(int i=0; i<res.count; i++)
			res.mat[i] = res_1.mat[i] - I1.mat[i];
		for(int i=0; i<res.count; i++)
			if((res.mat[i] - res_1.mat[i]) <= 1e-6 && (res.mat[i] - res_1.mat[i]) >= -1e-6)
				q++;
		if(res.count == q)
			check = 1;
		else
			for(int i=0; i<res.count; i++)
				res_1.mat[i] = res.mat[i];
	}
	I1.delalloc();
		
	for(int i=0; i<res.count; i++)
		ret.mat[i] = res.mat[i];
}

void core::clipper(float *inp, float *out, int fram)
{			// ALGORITMUS SSMN METODY //
	for(int a=0; a<fram; a++)
	{
		u.mat[0] = inp[a];
		I1.alloc(P1.row,x_1.col);
		I1.nasob(P1,x_1);
		for(int i=0; i<p.count; i++)
			p.mat[i] = I1.mat[i];
		I1.fill(0.);
		I1.nasob(P2,u);
		for(int i=0; i<p.count; i++)
			p.mat[i] = p.mat[i] + I1.mat[i];
		I1.fill(0.);
		I1.nasob(P3,u_1);
		for(int i=0; i<p.count; i++)
			p.mat[i] = p.mat[i] + I1.mat[i];
		I1.fill(0.);
		I1.nasob(P4,in_1);
		for(int i=0; i<p.count; i++)
			p.mat[i] = p.mat[i] + I1.mat[i];
		
		I1.delalloc();
		
		newton(pt2f,in_1,K,p,in);
		
		I1.alloc(x.row,x.col);
		I1.nasob(P5,x_1);
		for(int i=0; i<x.count; i++)
			x.mat[i] = I1.mat[i];
		for(int i=0; i<u_1.count; i++)
		{
			u_1.mat[i] = u_1.mat[i] + u.mat[i];
			in_1.mat[i] = in_1.mat[i] + in.mat[i];
		}
		I1.nasob(P6,u_1);
		for(int i=0; i<x.count; i++)
			x.mat[i] = x.mat[i] + I1.mat[i];
		I1.nasob(P7,in_1);
		for(int i=0; i<x.count; i++)
			x.mat[i] = x.mat[i] + I1.mat[i];

		
		I1.delalloc();
		I1.alloc(o.row,o.col);
		I1.nasob(AO,x);
		for(int i=0; i<o.count; i++)
			o.mat[i] = I1.mat[i];
		I1.nasob(BO,u);
		for(int i=0; i<o.count; i++)
			o.mat[i] = o.mat[i] + I1.mat[i];
		I1.nasob(CO,in);
		for(int i=0; i<o.count; i++)
			o.mat[i] = o.mat[i] + I1.mat[i];
		I1.delalloc();
		
		out[a] = o.mat[0];

		for(int i=0; i<x.count; i++)
			x_1.mat[i] = x.mat[i];
		for(int i=0; i<u.count; i++)
		{
			u_1.mat[i] = u.mat[i];
			in_1.mat[i] = in.mat[i];
		}	
	}
}

core::core(void)
{
}

core::core(int r, int f, void (*p2v)(core &), void (*p2f)(matica &, matica &, matica &, matica &))
{
	rad = r;
	alpha = 2.*f;
	pt2v = p2v;
	pt2f = p2f;
	if(rad > 1)
	{
		A.alloc(rad,rad);
		B.alloc(rad,rad-1);
		C.alloc(rad,rad-1);
		D.alloc(rad-1,rad);
		E.alloc(rad-1,rad-1);
		F.alloc(rad-1,rad-1);
		AO.alloc(1,rad);
		BO.alloc(1,rad-1);
		CO.alloc(1,rad-1);
		I.alloc(rad,rad);
		H.alloc(rad,rad);
		K.alloc(rad-1,rad-1);
		P1.alloc(rad-1,rad);
		P2.alloc(rad-1,rad-1);
		P3.alloc(rad-1,rad-1);
		P4.alloc(rad-1,rad-1);
		P5.alloc(rad,rad);
		P6.alloc(rad,rad-1);
		P7.alloc(rad,rad-1);
		p.alloc(rad-1,1);
		in.alloc(rad-1,1);
		in_1.alloc(rad-1,1);
		u.alloc(rad-1,1);
		u_1.alloc(rad-1,1);
		x.alloc(rad,1);
		x_1.alloc(rad,1);
	}
	else
	{
		A.alloc(rad,rad);
		B.alloc(rad,rad);
		C.alloc(rad,rad);
		D.alloc(rad,rad);
		E.alloc(rad,rad);
		F.alloc(rad,rad);
		AO.alloc(1,rad);
		BO.alloc(1,rad);
		CO.alloc(1,rad);
		I.alloc(rad,rad);
		H.alloc(rad,rad);
		K.alloc(rad,rad);
		P1.alloc(rad,rad);
		P2.alloc(rad,rad);
		P3.alloc(rad,rad);
		P4.alloc(rad,rad);
		P5.alloc(rad,rad);
		P6.alloc(rad,rad);
		P7.alloc(rad,rad);
		p.alloc(rad,1);
		in.alloc(rad,1);
		in_1.alloc(rad,1);
		u.alloc(rad,1);
		u_1.alloc(rad,1);
		x.alloc(rad,1);
		x_1.alloc(rad,1);
	}
	o.alloc(1,1);
	pt2v(*this);
}

core::~core(void)
{
}
