//-------------------------------------------------------------------------------------------------------
// VST Plug-Ins SDK
// Version 2.4		$Date: 2006/11/13 09:08:28 $
//
// Category     : VST 2.x SDK Samples
// Filename     : editor.h
// Created by   : Steinberg Media Technologies, Jiri Schimmel
// Description  : plugin tamplatee with Editor using VSTGUI
//
//  2006, Steinberg Media Technologies, All Rights Reserved
//
// Audified Plug-In Template
// Version 1.1		$Date: 2007/11/22 $
// Created by   : Audified Solutions
// Description  : Audified DPlug-In Template
//
//  2007, Audified Solutions, DISK Multimedia, s.r.o.
//-------------------------------------------------------------------------------------------------------

#ifndef __editor__
#define __editor__

#ifdef def_Editor

// include VSTGUI
#ifndef __vstgui__
#include "../vstgui/vstgui.h"
#endif


//-----------------------------------------------------------------------------
class CEditor : public AEffGUIEditor, public CControlListener
{
public:
	CEditor (AudioEffect* effect);
	virtual ~CEditor ();

public:
	virtual bool open (void* ptr);
	virtual void close ();

	virtual void setParameter (VstInt32 index, float value);
	virtual void valueChanged (CDrawContext* context, CControl* control);
	virtual void idle(void);

private:
	// background bitmap
	CBitmap* hBackground;
	CHorizontalSlider* myFader[PARAM_NUMBER];
	CTextLabel* myDisplay[PARAM_NUMBER];
	CTextLabel* myLabel[PARAM_NUMBER];
	CParamDisplay* myParam[PARAM_NUMBER];
};

#endif // def_Editor
#endif
