#include "matica.h"
#include "iostream"
#define _USE_MATH_DEFINES
#include "math.h"

using namespace std;

void matica::fill(float c)
{
	for(int i=0; i<count; i++)
		mat[i] = c;
}

void matica::print(void)
{
	for(int i=0; i<row; i++)
	{
		for(int j=0; j<col; j++)
			cout << mat[(j*row)+i] << "\t";
		cout << endl;
	}
	cout << endl;
		
}

void matica::eye(void)
{
	for(int i=0; i<row; i++)
		for(int j=0; j<col; j++)
		{
			if(i == j)
				mat[j*col+i] = 1.;
			else
				mat[j*col+i] = 0.;
		}
}

void matica::inv(matica &A, matica &B)
{
	float c;
	for(int i=0; i<A.row; i++)
	{
		c = 1/A.mat[i*A.col+i];
		for(int j=0; j<A.col; j++)
		{
			A.mat[j*A.col+i]=c*A.mat[j*A.col+i];
			B.mat[j*A.col+i]=c*B.mat[j*A.col+i];
		}

		if(i<(A.row-1))
			for(int k=i+1; k<A.row; k++)
			{
				c = A.mat[i*A.col+k];
				for(int j=0; j<A.col; j++)
				{
					A.mat[j*A.col+k]=A.mat[j*A.col+k]-c*A.mat[j*A.col+i];
					B.mat[j*A.col+k]=B.mat[j*A.col+k]-c*B.mat[j*A.col+i];
				}
			}
	}

	for(int i=A.row-1; i>0; i--)
	{
		if(i>0)
			for(int k=i-1; k>-1; k--)
			{
				c = A.mat[i*A.col+k];
				for(int j=0; j<A.col; j++)
				{
					A.mat[j*A.col+k]=A.mat[j*A.col+k]-c*A.mat[j*A.col+i];
					B.mat[j*A.col+k]=B.mat[j*A.col+k]-c*B.mat[j*A.col+i];
				}
			}
	}
	for(int i=0; i<count; i++)
		mat[i]=B.mat[i];
}

void matica::nasob(matica &A, matica &B)
{
	this->fill(0.);
	for(int i=0; i<row; i++)														//riadky vysl. mat
		for(int j=0; j<col; j++)													//stlpce vysl. mat
			for(int k=0; k<B.row; k++)												//riadky
				mat[row*j + i] = mat[row*j+i] + A.mat[row*k+i] * B.mat[B.row*j+k];	//
}

void matica::alloc(int r, int c)
{
	row = r;
	col = c;
	count = r*c;
	mat = new float[count];
	for(int i=0; i<count; i++)
		mat[i] = 0.;
}

void matica::delalloc(void)
{
	row = 0;
	delete mat;	
}

matica::matica(void)
{
	row = 0;
}

matica::matica(int r, int c)
{
	row = r;
	col = c;
	count = r * c;
	mat = new float[count];
	for(int i=0; i<count; i++)
		mat[i] = 0.;
}

matica::matica(const matica &X)
{
	row = X.row;
	col = X.col;
	count = X.count;
	mat = new float[count];
	for(int i=0; i<count; i++)
		mat[i] = X.mat[i];
}

matica::~matica(void)
{
	if(row > 0)
		delete mat;
}
